from ado_wrapper.utils import get_resource_variables, get_editable_fields

def generate_editable_attributes_types() -> None:
    resource_objects = get_resource_variables().values()
    string = "# THIS FILE IS AUTOGENERATED BY `generate_type_hints.py`, please don't edit it manually!"
    string += "\nfrom typing import Literal\n\n\n"
    for resource in resource_objects:
        infix = ', '.join([f'"{field}"' for field in get_editable_fields(resource)])
        if not infix:
            continue
        string += f"{resource.__name__}EditableAttribute = Literal[{infix}]\n"  # fmt: skip
    string += "\n\nResourceType = Literal[\n    "+", ".join([f'"{resource.__name__}"'+("\n    " if i==(len(resource_objects)//2) else "") for i, resource in enumerate(resource_objects)])+"  # fmt: skip\n]"
    with open("attribute_types.py", "w", encoding="utf-8") as f:
        f.write(string+"\n")

generate_editable_attributes_types()
